## kissplice 2.6.2

=== CMakeLists.txt ===
# 3.1 required by: zlib targets, Threads (OpenMP target fallback)
cmake_minimum_required(VERSION 3.1)

project(
  kissplice
  VERSION 2.6.2 # Definition which is propagated through PROJECT_VERSION
  LANGUAGES CXX
)

set(CMAKE_CXX_STANDARD 11) # Default to C++11 for C++ targets
set(CMAKE_CXX_STANDARD_REQUIRED ON) # Fail if not supported (very old compiler at this point)

# Build type, should be set by user. Useful predefined values (see `cmake -LH`): Debug, Release, RelWithDebInfo.
# Default to non-persistent RelWithDebInfo (-g -O2) if no build type is specified.
if(NOT CMAKE_BUILD_TYPE)
  # Not cached : this keeps the help string (`cmake -LH`) and user setting intact.
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# Cmake already adds -g in Debug and -O3 in Release, so no need to set them manually.
# Enables common warnings for ALL targets.
add_compile_options(-Wall)
# Profiling with gprof requires -pg which is better to add manually with -DCMAKE_(C|CXX)_FLAGS=-pg
# `perf` is a more modern replacement anyway and does not require special compilation.

# Date for manpage and pdf doc
string(TIMESTAMP CONFIGURE_DATE "%Y-%m-%d" UTC)

###############################################################################
# structure and paths
# kissplice is composed of:
# - internal binaries which should go to <prefix>/libexec/kissplice
# - a main frontend "binary" which is a python script which should go to <prefix>/bin
# The frontend script expects this architecture to hold (with relative paths) to find the internal binaries.
# For tests to work, this architecture is replicated in the temporary build directory wih <prefix>=<build_dir>
include(GNUInstallDirs) # GNU standard installation directories definitions (bin, libexec, and definitions for doc/man)
# Path to internal binaries relative to prefix. This is used in install() for internal binaries, to let the cmake prefix handling work.
set(RELATIVE_INTERNAL_BINDIR "${CMAKE_INSTALL_LIBEXECDIR}/kissplice") 
# Absolute path to build location of internal binaries. This is used to define RUNTIME_OUTPUT_DIRECTORY of internal binaries (build dir).
set(BUILD_INTERNAL_BINDIR "${PROJECT_BINARY_DIR}/${RELATIVE_INTERNAL_BINDIR}")
# Absolute path to build location of frontend binaries (kissplice script only for now)
set(BUILD_BINDIR "${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
# Relative path from script to internal binaries directory, written to kissplice script
file(RELATIVE_PATH KISSPLICE_BINDIR_TO_INTERNAL_BINDIR "${BUILD_BINDIR}" "${BUILD_INTERNAL_BINDIR}")

# Complete the main script template to include the relative directory
configure_file("${PROJECT_SOURCE_DIR}/kissplice.in.py" "${BUILD_BINDIR}/kissplice" @ONLY)
install(PROGRAMS "${BUILD_BINDIR}/kissplice" DESTINATION "${CMAKE_INSTALL_BINDIR}")

###############################################################################
# bcalm dependency
# bcalm is a binary program needed for tests and after install.
# It is packaged on debian, so default to using the system wide version (best practice for packaging kissplice).
# The USE_BUNDLED_BCALM option can be used to locally build and ship an install of bcalm, placed in the internal binaries directory.
# In either case a "bcalm" executable will be placed in internal binaries (bundled binary or a redirect script).
# This simplifies kissplice.py which can always look in libexec/kissplice/bcalm.
# This "bcalm" is placed in both build dir and install dir.
option(
  USE_BUNDLED_BCALM
  "by default kissplice requires an already installed bcalm program ; enable this option to bundle a local bcalm with kissplice."
  OFF
)
if(NOT USE_BUNDLED_BCALM)
  # Check system bcalm
  find_program(SYSTEM_BCALM_PATH NAMES bcalm)
  mark_as_advanced(SYSTEM_BCALM_PATH)
  if(NOT SYSTEM_BCALM_PATH)
    message(
      FATAL_ERROR "bcalm not found. install it with system packages,\
      or provide path to a custom install with -DCMAKE_PROGRAM_PATH=<prefix>,\
      or use bundled bcalm version with -DUSE_BUNDLED_BCALM=TRUE"
    )
  endif()
  message(STATUS "Found bcalm tool: ${SYSTEM_BCALM_PATH}")
  # Add a simple redirection to system bcalm in internal binaries, as kissplice expects bcalm there.
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/bcalm_redirect.in" "${BUILD_INTERNAL_BINDIR}/bcalm" @ONLY)
else()
  message(STATUS "using bundled version of bcalm (will be compiled at make time)")
  include(ExternalProject)
  ExternalProject_Add(
    bundled_bcalm
    PREFIX bundled_bcalm
    GIT_REPOSITORY "https://github.com/GATB/bcalm.git"
    GIT_TAG v2.2.3
    UPDATE_COMMAND "" # Prevent rebuilding bcalm everytime
    # Prevent install which is broken (vendored hdf5 ignores CMAKE_INSTALL_PREFIX).
    # Manually extract the bcalm binary to our internal binary build dir. This is run inside bcalm build dir.
    INSTALL_COMMAND "${CMAKE_COMMAND}" -E copy bcalm "${BUILD_INTERNAL_BINDIR}"
  )
endif()
install(PROGRAMS "${BUILD_INTERNAL_BINDIR}/bcalm" DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

###############################################################################
# subdirs
add_subdirectory(thirdparty) # kissreads
add_subdirectory(modules) # various ks_* internal tools
add_subdirectory(man) # manpage
add_subdirectory(doc) # user guide

enable_testing()
add_subdirectory(tests)

=== doc/CMakeLists.txt ===
option(
    USER_GUIDE
    "compile and install a pdf user_guide ; requires pdflatex and standard latex packages"
    ON
)
if (USER_GUIDE)
    find_package(LATEX)
    if(NOT PDFLATEX_COMPILER)
        message(FATAL_ERROR "pdflatex not found, install latex or disable user_guide generation with -DUSER_GUIDE=OFF")
    endif()

    # add version number
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/user_guide.in.tex" "${CMAKE_CURRENT_BINARY_DIR}/user_guide.tex" @ONLY)

    # Call pdflatex twice to fix references.
    # Called with pwd=source_dir to have access to pictures, but -output-directory=binary_dir to prevent clutter.
    # -halt-on-error -interaction=nonstopmode are here to prevent any user prompt and have a clean stop+error instead.
    # The quiet.sh script tries to remove verbosity if VERBOSE make is not requested.
    add_custom_command(
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/user_guide.pdf"
        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/quiet.sh" "${PDFLATEX_COMPILER}" -halt-on-error -interaction=nonstopmode "-output-directory=${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_BINARY_DIR}/user_guide.tex"
        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/quiet.sh" "${PDFLATEX_COMPILER}" -halt-on-error -interaction=nonstopmode "-output-directory=${CMAKE_CURRENT_BINARY_DIR}" "${CMAKE_CURRENT_BINARY_DIR}/user_guide.tex"
        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/rm_pdf_id.sh" "${CMAKE_CURRENT_BINARY_DIR}/user_guide.pdf"
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
        MAIN_DEPENDENCY "${CMAKE_CURRENT_BINARY_DIR}/user_guide.tex"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/quiet.sh" "${CMAKE_CURRENT_SOURCE_DIR}/rm_pdf_id.sh"
    )
    add_custom_target(doc ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/user_guide.pdf")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/user_guide.pdf" DESTINATION "${CMAKE_INSTALL_DOCDIR}")
else()
    message(WARNING "user_guide.pdf will not be built, disabled by USER_GUIDE variable")
endif()

=== man/CMakeLists.txt ===
# Fill manpage template with version and date
# TODO maybe use tools like help2man to automate manpage, considering this is mostly a --help message ?
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/kissplice.in.1" "${CMAKE_CURRENT_BINARY_DIR}/kissplice.1" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kissplice.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1")

=== tests/CMakeLists.txt ===
ADD_SUBDIRECTORY(integration_tests)
ADD_SUBDIRECTORY(functional_tests)

add_test(IsBcalmStartable "${BUILD_INTERNAL_BINDIR}/bcalm" -help)

=== tests/functional_tests/CMakeLists.txt ===
# ============================================================================
# Tests on: /data/HBM75brain_1000000.fasta 
#      +   /data/HBM75liver_1000000.fasta
# ============================================================================
add_test(ksBubbleEnumerationTest "${CMAKE_CURRENT_SOURCE_DIR}/ksBubbleEnumerationTest.py" "${BUILD_INTERNAL_BINDIR}")
set_tests_properties(ksBubbleEnumerationTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

# ============================================================================
# Tests on: /data/HBM75brain_1000000.fasta 
#      +   /data/HBM75liver_1000000.fasta
# ============================================================================
add_test(ksRunModulesTest "${CMAKE_CURRENT_SOURCE_DIR}/ksRunModulesTest.py" "${BUILD_INTERNAL_BINDIR}")
set_tests_properties(ksRunModulesTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

# ============================================================================
# Tests on: /data/HBM75brain_1000000.fasta 
#      +   /data/HBM75liver_1000000.fasta
# ============================================================================
add_test(ksErrorRemovalTest "${CMAKE_CURRENT_SOURCE_DIR}/ksErrorRemovalTest.py" "${BUILD_INTERNAL_BINDIR}")
set_tests_properties(ksErrorRemovalTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

=== tests/integration_tests/CMakeLists.txt ===
# ============================================================================
# Basic test: Does kissplice run ?
# ============================================================================
add_test(KisspliceBasicTest "${BUILD_BINDIR}/kissplice" -h)

# ============================================================================
# Tests on: /data/HBM75brain_100000.fasta 
#      +   /data/HBM75liver_100000.fasta
# Comparing the graph and the count file
# ============================================================================
add_test(KisspliceDBGTest "${CMAKE_CURRENT_SOURCE_DIR}/kisspliceDBGTest.py" "${BUILD_BINDIR}")

# ============================================================================
# Tests on: /data/HBM75brain_100000.fasta 
#      +   /data/HBM75liver_100000.fasta
# ============================================================================
add_test(KisspliceTwoSequencesTest "${CMAKE_CURRENT_SOURCE_DIR}/kisspliceTwoSequencesTest.py" "${BUILD_BINDIR}")
set_tests_properties(KisspliceTwoSequencesTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

# ============================================================================
# Tests on: //data/graph_HBM75brain_100000_HBM75liver_100000_k25 + 
#              /data/HBM75brain_100000.fasta
# ============================================================================

add_test(KisspliceGraphAndSequenceTest "${CMAKE_CURRENT_SOURCE_DIR}/kisspliceGraphAndSequenceTest.py" "${BUILD_BINDIR}")
set_tests_properties(KisspliceGraphAndSequenceTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

# ============================================================================
# Tests on: //data/graph_HBM75brain_100000_HBM75liver_100000_k25 
# ============================================================================
add_test(KisspliceGraphTest "${CMAKE_CURRENT_SOURCE_DIR}/kisspliceGraphTest.py" "${BUILD_BINDIR}")
set_tests_properties(KisspliceGraphTest PROPERTIES PASS_REGULAR_EXPRESSION "test SUCCESSFUL")

=== thirdparty/kissreads/src/CMakeLists.txt ===
# kissreads requirements
find_package(ZLIB REQUIRED) # imports the ZLIB::ZLIB target
find_package(OpenMP) # for CMake 3.9+, import targets OpenMP::OpenMP_<lang>
if(DEFINED OpenMP_CXX_FLAGS AND NOT TARGET OpenMP::OpenMP_CXX)
  # For older CMake emulate target (https://cliutils.gitlab.io/modern-cmake/chapters/packages/OpenMP.html)
  find_package(Threads REQUIRED)
  add_library(OpenMP::OpenMP_CXX IMPORTED INTERFACE)
  set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS})
  set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)
endif()

# Get parent directory for a nicer alternative to "../include"
get_property(PARENT_DIRECTORY DIRECTORY PROPERTY PARENT_DIRECTORY)

# Kissreads binaries
add_executable(ks_kissreadsSNPS commons.cpp extension_algorithm.cpp interface_libchash.cpp libchash.cpp outputs.cpp coherent_algorithm.cpp couple.cpp fragment_index.cpp kissReads.cpp list.cpp tree.cpp fragment_info.cpp Utils.cpp)
target_compile_definitions(ks_kissreadsSNPS PRIVATE CLASSICAL_SPANNING)
target_include_directories(ks_kissreadsSNPS PRIVATE "${PARENT_DIRECTORY}/include")
target_link_libraries(ks_kissreadsSNPS ZLIB::ZLIB m)
set_property(TARGET ks_kissreadsSNPS PROPERTY RUNTIME_OUTPUT_DIRECTORY "${BUILD_INTERNAL_BINDIR}")
install(TARGETS ks_kissreadsSNPS RUNTIME DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

add_executable(ks_kissreadsSplice commons.cpp extension_algorithm.cpp interface_libchash.cpp libchash.cpp outputs.cpp coherent_algorithm.cpp couple.cpp fragment_index.cpp kissReads.cpp list.cpp tree.cpp fragment_info.cpp Utils.cpp)
target_compile_definitions(ks_kissreadsSplice PRIVATE CLASSICAL_SPANNING INPUT_FROM_KISSPLICE)
target_include_directories(ks_kissreadsSplice PRIVATE "${PARENT_DIRECTORY}/include")
target_link_libraries(ks_kissreadsSplice ZLIB::ZLIB m)
set_property(TARGET ks_kissreadsSplice PROPERTY RUNTIME_OUTPUT_DIRECTORY "${BUILD_INTERNAL_BINDIR}")
install(TARGETS ks_kissreadsSplice RUNTIME DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

if(TARGET OpenMP::OpenMP_CXX)
    target_link_libraries(ks_kissreadsSNPS OpenMP::OpenMP_CXX)
    target_link_libraries(ks_kissreadsSplice OpenMP::OpenMP_CXX)
endif()

=== debian/changelog ===
kissplice (2.6.2-2) unstable; urgency=medium

  * Team upload.

  [ Eric Long ]
  * Add build target for riscv64.
    Closes: #1027357

 -- Sascha Steinbiss <satta@debian.org>  Fri, 20 Jan 2023 19:37:26 +0100

kissplice (2.6.2-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 30 Jun 2022 16:27:19 +0200

kissplice (2.6.1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Upstream moved to https://gitlab.inria.fr
  * New upstream version
  * Set upstream metadata fields: Repository, Repository-Browse.
  * Build-Depends: texlive-latex-base

  [ Francois Gindraud ]
  * Update dependencies
  * Remove gcc10 patch
  * Replace redirection script with symlink to bcalm
  * New upstream version
  * Use generated doc and upsteam manpage

 -- Francois Gindraud <francois.gindraud@inria.fr>  Wed, 06 Apr 2022 16:19:49 +0200

=== debian/control ===
Source: kissplice
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Francois Gindraud <francois.gindraud@inria.fr>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cmake,
               python3-dev,
               libpython3-stdlib,
               zlib1g-dev,
               texlive-latex-recommended,
               bcalm <!nocheck>
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/kissplice
Vcs-Git: https://salsa.debian.org/med-team/kissplice.git
Homepage: http://kissplice.prabi.fr/
Rules-Requires-Root: no

Package: kissplice
Architecture: any-amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64 any-ppc64el any-sparc64 riscv64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends},
         bcalm
Description: Detection of various kinds of polymorphisms in RNA-seq data
 KisSplice is a piece of software that enables the analysis of RNA-seq data
 with or without a reference genome. It is an exact local transcriptome
 assembler that allows one to identify SNPs, indels and alternative splicing
 events. It can deal with an arbitrary number of biological conditions, and
 will quantify each variant in each condition.
 It has been tested on Illumina datasets of up to 1G reads.
 Its memory consumption is around 5Gb for 100M reads.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#
#   cc1plus: error: '-Wformat-security' ignored without '-Wformat' [-Werror=format-security]
#export DEB_CPPFLAGS_MAINT_APPEND = -Wno-unused-result -Wno-parentheses -Wno-error=format-security

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Force texlive to respect SOURCE_DATE_EPOCH for reproducibility of pdf user guide
export FORCE_SOURCE_DATE=1

include /usr/share/dpkg/default.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=lib/

override_dh_compress:
	dh_compress --exclude=.pdf

override_dh_install:
	rm -rf debian/$(DEB_SOURCE)/usr/README.md debian/$(DEB_SOURCE)/build debian/$(DEB_SOURCE)/builds
	rm -f debian/$(DEB_SOURCE)/usr/lib/kissplice/bcalm
	mkdir -p debian/$(DEB_SOURCE)/usr/share/$(DEB_SOURCE)
	mv debian/$(DEB_SOURCE)/usr/bin/kissplice debian/$(DEB_SOURCE)/usr/share/$(DEB_SOURCE)/kissplice.py

override_dh_auto_clean:
	dh_auto_clean
	find . -name __pycache__/ -type d | xargs rm -rf

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=auto" \
  https://gitlab.inria.fr/erable/kissplice/-/tags .*/@PACKAGE@-@ANY_VERSION@\.tar\.gz

## kissplice 2.6.7

=== CMakeLists.txt ===
# 3.9 required by: zlib targets, OpenMP target
cmake_minimum_required(VERSION 3.9)

project(
  kissplice
  VERSION 2.6.7 # Definition which is propagated through PROJECT_VERSION
  LANGUAGES CXX
)

set(CMAKE_CXX_STANDARD 14) # Default to C++14 for C++ targets
set(CMAKE_CXX_STANDARD_REQUIRED ON) # Fail if not supported (very old compiler at this point)

# Build type, should be set by user. Useful predefined values (see `cmake -LH`): Debug, Release, RelWithDebInfo.
# Default to non-persistent RelWithDebInfo (-g -O2) if no build type is specified.
if(NOT CMAKE_BUILD_TYPE)
  # Not cached : this keeps the help string (`cmake -LH`) and user setting intact.
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# Cmake already adds -g in Debug and -O3 in Release, so no need to set them manually.
# Enables common warnings for ALL targets.
add_compile_options(-Wall)

# Date for manpage and pdf doc
string(TIMESTAMP CONFIGURE_DATE "%Y-%m-%d" UTC)

###############################################################################
# structure and paths
# kissplice is composed of:
# - internal binaries which should go to <prefix>/libexec/kissplice
# - a entry point "binary" which is a python script which should go to <prefix>/bin
# The entry point script locates internal binaries using relative paths from itself.
# For tests to work, this architecture is replicated in the temporary build directory wih <prefix>=<build_dir>.
include(GNUInstallDirs) # GNU standard installation directories definitions (bin, libexec, and definitions for doc/man)
# Path to internal binaries relative to prefix. This is used in install() for internal binaries, to let the cmake prefix handling work.
set(RELATIVE_INTERNAL_BINDIR "${CMAKE_INSTALL_LIBEXECDIR}/kissplice") 
# Absolute path to build location of internal binaries. This is used to define RUNTIME_OUTPUT_DIRECTORY of internal binaries (build dir).
set(BUILD_INTERNAL_BINDIR "${PROJECT_BINARY_DIR}/${RELATIVE_INTERNAL_BINDIR}")
# Absolute path to build location of main entry point (kissplice script only for now)
set(BUILD_BINDIR "${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
# Relative path from script to internal binaries directory, written to kissplice script
file(RELATIVE_PATH KISSPLICE_BINDIR_TO_INTERNAL_BINDIR "${BUILD_BINDIR}" "${BUILD_INTERNAL_BINDIR}")

###############################################################################
# bcalm dependency : bcalm is a binary program needed for tests and after install.
# It is packaged on debian, so default to using the system wide version (best practice for packaging kissplice).
# The USE_BUNDLED_BCALM option can be used to locally build and ship an install of bcalm, placed in the internal binaries directory (build and install).
# The BCALM_PACKAGING_MODE string variable propagates this choice to the kissplice script (with known values unlike USE_BUNDLED_BCALM).
option(
  USE_BUNDLED_BCALM
  "by default kissplice requires an already installed bcalm program ; enable this option to bundle a local bcalm with kissplice."
  OFF
)
if(NOT USE_BUNDLED_BCALM)
  # Check system bcalm
  find_program(SYSTEM_BCALM_PATH NAMES bcalm)
  mark_as_advanced(SYSTEM_BCALM_PATH)
  if(SYSTEM_BCALM_PATH)
    message(STATUS "Found bcalm tool: ${SYSTEM_BCALM_PATH}")
  else()
    message(WARNING "bcalm not found in PATH. install it with system packages, or use bundled bcalm version with -DUSE_BUNDLED_BCALM=TRUE")
  endif()
  set(BCALM_PACKAGING_MODE "system")
else()
  message(STATUS "using bundled version of bcalm (will be compiled at make time)")
  include(ExternalProject)
  ExternalProject_Add(
    bundled_bcalm
    PREFIX bundled_bcalm
    # Using commit with Mac fix from a fork awaiting merge. FIXME replace by upstream (GATB user) when merged.
    GIT_REPOSITORY "https://github.com/fgindraud/bcalm.git"
    GIT_TAG cf371b697c537ca492da877f2531ebd494a4c79e
    UPDATE_COMMAND "" # Prevent rebuilding bcalm everytime
    # Manually extract the bcalm binary to our internal binary build dir, instead of broken install target.
    # This is run inside bcalm build dir.
    INSTALL_COMMAND "${CMAKE_COMMAND}" -E copy bcalm "${BUILD_INTERNAL_BINDIR}"
  )
  install(PROGRAMS "${BUILD_INTERNAL_BINDIR}/bcalm" DESTINATION "${RELATIVE_INTERNAL_BINDIR}")
  set(BCALM_PACKAGING_MODE "bundled")
endif()

###############################################################################
# Complete the main script template to include the relative directory and bcalm location.
configure_file("${PROJECT_SOURCE_DIR}/kissplice.in.py" "${BUILD_BINDIR}/kissplice" @ONLY)
install(PROGRAMS "${BUILD_BINDIR}/kissplice" DESTINATION "${CMAKE_INSTALL_BINDIR}")

###############################################################################
# subdirs
add_subdirectory(thirdparty) # kissreads
add_subdirectory(modules) # various ks_* internal tools
add_subdirectory(man) # manpage
add_subdirectory(doc) # user guide

enable_testing()
add_subdirectory(tests)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 option(
     USER_GUIDE
     "compile and install a pdf user_guide ; requires pdflatex and standard latex packages"
-    ON
+    OFF
 )
 if (USER_GUIDE)
     find_package(LATEX)

=== modules/CMakeLists.txt ===
add_executable(ks_clean_duplicates CleanDuplicates.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp LabelledCEdge.cpp Utils.cpp)
set_property(TARGET ks_clean_duplicates PROPERTY RUNTIME_OUTPUT_DIRECTORY "${BUILD_INTERNAL_BINDIR}")
install(TARGETS ks_clean_duplicates RUNTIME DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

add_executable(ks_bubble_enumeration  BubbleEnumeration.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp LabelledCEdge.cpp Utils.cpp)
set_property(TARGET ks_bubble_enumeration PROPERTY RUNTIME_OUTPUT_DIRECTORY "${BUILD_INTERNAL_BINDIR}")
install(TARGETS ks_bubble_enumeration RUNTIME DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

add_executable(ks_run_modules run.cpp CycleCompression.cpp NGraph.cpp CGraph.cpp LabelledCEdge.cpp SplitBcc.cpp Utils.cpp)
set_property(TARGET ks_run_modules PROPERTY RUNTIME_OUTPUT_DIRECTORY "${BUILD_INTERNAL_BINDIR}")
install(TARGETS ks_run_modules RUNTIME DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

add_executable(ks_error_removal ErrorRemoval.cpp LabelledCEdge.cpp Utils.cpp)
set_property(TARGET ks_error_removal PROPERTY RUNTIME_OUTPUT_DIRECTORY "${BUILD_INTERNAL_BINDIR}")
install(TARGETS ks_error_removal RUNTIME DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

add_executable(ks_print_bcc PrintBcc.cpp Utils.cpp)
set_property(TARGET ks_print_bcc PROPERTY RUNTIME_OUTPUT_DIRECTORY "${BUILD_INTERNAL_BINDIR}")
install(TARGETS ks_print_bcc RUNTIME DESTINATION "${RELATIVE_INTERNAL_BINDIR}")

=== tests/CMakeLists.txt ===
ADD_SUBDIRECTORY(integration_tests)
ADD_SUBDIRECTORY(functional_tests)

=== thirdparty/CMakeLists.txt ===
add_subdirectory(kissreads)

=== thirdparty/kissreads/src/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,6 @@
 # kissreads requirements
 find_package(ZLIB REQUIRED) # imports the ZLIB::ZLIB target
 find_package(OpenMP) # for CMake 3.9+, import targets OpenMP::OpenMP_<lang>
-if(DEFINED OpenMP_CXX_FLAGS AND NOT TARGET OpenMP::OpenMP_CXX)
-  # For older CMake emulate target (https://cliutils.gitlab.io/modern-cmake/chapters/packages/OpenMP.html)
-  find_package(Threads REQUIRED)
-  add_library(OpenMP::OpenMP_CXX IMPORTED INTERFACE)
-  set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_COMPILE_OPTIONS ${OpenMP_CXX_FLAGS})
-  set_property(TARGET OpenMP::OpenMP_CXX PROPERTY INTERFACE_LINK_LIBRARIES ${OpenMP_CXX_FLAGS} Threads::Threads)
-endif()
 
 # Get parent directory for a nicer alternative to "../include"
 get_property(PARENT_DIRECTORY DIRECTORY PROPERTY PARENT_DIRECTORY)

=== debian/changelog ===
kissplice (2.6.7-2) unstable; urgency=medium

  * Team upload.
  * d/rules: make tests sequential. (Closes: #1104392)
  * d/control: declare compliance to standards version 4.7.2.
  * tests-2to3.patch: normalize Last-Update timestamp.

 -- Étienne Mollier <emollier@debian.org>  Wed, 30 Apr 2025 21:27:51 +0200

kissplice (2.6.7-1) unstable; urgency=medium

  $ Team upload
  * Advertising repacking with +dfsg suffix for upcoming upstream versions
  * Shipping the Python file directly in /usr/bin, not symlinking to
    /usr/share/kissplice anymore
  * Adding internal binaries in a subdir of /usr/lib/${DEB_HOST_MULTIARCH}

  [ François Gindraud ]
  * Propagate upstream build system changes for bcalm and guide
  * Fix dh_auto_clean

  [ Andreas Tille ]
  * New upstream version
    Closes: #1073482, #1074658
  * Standards-Version: 4.7.0 (routine-update)

 -- Pierre Gruet <pgt@debian.org>  Wed, 07 Aug 2024 17:30:12 +0200

kissplice (2.6.2-3) unstable; urgency=medium

  * Add build support for loongarch64
    Closes: #1058716
  * Standards-Version: 4.6.2 (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  Use secure URI in Homepage field.
  Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Andreas Tille <tille@debian.org>  Tue, 09 Jan 2024 20:32:24 +0100

=== debian/control ===
--- 
+++ 
@@ -5,21 +5,21 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                cmake,
                python3-dev,
                libpython3-stdlib,
                zlib1g-dev,
                texlive-latex-recommended,
                bcalm <!nocheck>
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/kissplice
 Vcs-Git: https://salsa.debian.org/med-team/kissplice.git
-Homepage: http://kissplice.prabi.fr/
+Homepage: https://kissplice.prabi.fr/
 Rules-Requires-Root: no
 
 Package: kissplice
-Architecture: any-amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64 any-ppc64el any-sparc64 riscv64
+Architecture: any-amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64 any-ppc64el any-sparc64 loong64 riscv64
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          ${python3:Depends},

=== debian/rules ===
--- 
+++ 
@@ -16,20 +16,22 @@
 include /usr/share/dpkg/default.mk
 
 %:
-	dh $@ --with python3
+	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=lib/
+	dh_auto_configure -- -DCMAKE_INSTALL_LIBEXECDIR=lib/$(DEB_HOST_MULTIARCH) -DUSER_GUIDE=ON
+
+override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	dh_auto_test --no-parallel
+endif
 
 override_dh_compress:
 	dh_compress --exclude=.pdf
 
 override_dh_install:
 	rm -rf debian/$(DEB_SOURCE)/usr/README.md debian/$(DEB_SOURCE)/build debian/$(DEB_SOURCE)/builds
-	rm -f debian/$(DEB_SOURCE)/usr/lib/kissplice/bcalm
-	mkdir -p debian/$(DEB_SOURCE)/usr/share/$(DEB_SOURCE)
-	mv debian/$(DEB_SOURCE)/usr/bin/kissplice debian/$(DEB_SOURCE)/usr/share/$(DEB_SOURCE)/kissplice.py
 
 override_dh_auto_clean:
 	dh_auto_clean
-	find . -name __pycache__/ -type d | xargs rm -rf
+	find . -name __pycache__ -type d | xargs rm -rf

=== debian/watch ===
version=4

opts="searchmode=plain, repack, repacksuffix=+dfsg, compression=xz, dversionmangle=auto" \
 https://gitlab.inria.fr/erable/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
